<template>
  <div>
    <Map
      v-if="!detail"
      @onMounted="mapMounted"
    />

    <draggable
      :list="stationSelected"
      item-key="id"
      class="q-list q-list--bordered q-list--separator q-mt-xl"
      ghost-class="ghost"
      :disabled="detail"
    >
      <template #item="{ element }">
        <q-item
          v-ripple
          clickable
        >
          <q-item-section avatar>
            <q-icon
              v-if="!detail"
              name="drag_indicator"
              color="primary"
            />
          </q-item-section>

          <q-item-section>{{ element.name }}</q-item-section>

          <q-item-section side>
            <q-btn
              v-if="!detail"
              icon="close"
              flat
              round
              @click="() => deleteSelected(element.id)"
            />
          </q-item-section>
        </q-item>
      </template>
    </draggable>
  </div>
</template>

<script lang="ts">
import { defineComponent, PropType, ref } from '@vue/runtime-core'
import _ from 'lodash'
import { useQuasar } from 'quasar'
import draggable from 'vuedraggable'
import { JourneyModel, StationModel } from 'web_trains_types'

import Map from '@/components/Map/Map.vue'
import { stationService } from '@/service'

export default defineComponent({
  name: 'MapSelect',
  components: { Map, draggable },
  props: {
    journeyprom: {
      type: Object as PropType<Promise<JourneyModel>>,
      reguired: true,
      default: null
    },
    detail: {
      type: Boolean,
      reguired: false,
      default: false
    }
  },
  setup (props): any {
    const $q = useQuasar()

    const stationSelected = ref<StationModel[]>([])
    const stationAll = ref<StationModel[]>()
    const stationMap: ({id: number, elem: HTMLElement}[]) = []

    const findStation = (id: number|null|undefined): StationModel|undefined => stationAll.value?.find((station) => station.id === id)

    const setUsed = (id: number|null|undefined) => {
      stationMap.filter(sm => sm.id === id)?.forEach(item => {
        item.elem.classList.add('track_used')
      })
    }

    const unsetUsed = (id: number|null|undefined) => {
      stationMap.filter(sm => sm.id === id)?.forEach(item => {
        item.elem.classList.remove('track_used')
      })
    }

    stationService.getAll()
      .then(stations => {
        stationAll.value = stations

        if (props.journeyprom !== null) {
          props.journeyprom.then((journey) => {
            const from = findStation(journey.stationFromId)
            const to = findStation(journey.stationToId)

            if (!from || !to) {
              return
            }

            stationSelected.value.push(from)
            setUsed(journey.stationFromId)

            journey.section?.forEach((section) => {
              const foundSection = findStation(section.id)

              if (!foundSection) {
                return
              }

              stationSelected.value.push(foundSection)
              setUsed(section.id)
            })

            stationSelected.value.push(to)
            setUsed(journey.stationToId)
          })
        }
      })

    const onStationClick = (elem: HTMLElement, stationId: number) => {
      const clickedStation = findStation(stationId)
      if (!clickedStation) {
        return
      }

      if (stationSelected.value?.find((station) => station.id === stationId)) {
        $q.notify({
          type: 'warning',
          message: 'Stanice je již použita'
        })
        return
      }

      stationSelected.value?.push(clickedStation)
      elem.classList.add('track_used')
    }

    const mapMounted = (pathAll: any) => {
      for (const path of pathAll) {
        if (!props.detail) {
          path.elem.onclick = (click: any) => onStationClick(click.target, path.id)
        }
        stationMap.push(path)
      }
    }

    const deleteSelected = (id: number) => {
      if (stationSelected.value === undefined) {
        return
      }

      _.remove(stationSelected.value, (obj) => obj.id === id)
      unsetUsed(id)
    }

    return {
      mapMounted,
      stationSelected,
      deleteSelected,
      getSelected: () => stationSelected.value
    }
  }
})

</script>
